﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraGridCalcManDemo
{
    public partial class Form1 : Form
    {
        Random r = new Random();
        DataTable table;
        public Form1()
        {
            InitializeComponent();

            table = new DataTable();
            table.Columns.Add("Number1", typeof(int));
            table.Columns.Add("Number2", typeof(int));

            FillTable();

            ultraGrid1.InitializeLayout += UltraGrid1_InitializeLayout;
            ultraGrid1.DataSource = table;            
        }

        public void FillTable()
        {
            for (int i = 0; i < 10; i++)
            {
                DataRow row = table.NewRow();
                row[0] = r.Next(1000);
                row[1] = r.Next(1000);
                table.Rows.Add(row);
            }

        }

        private void UltraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridBand band = e.Layout.Bands[0];
            UltraGridColumn col = band.Columns.Add("Num1+Num2");
            col.Formula = "[Number1] + [Number2]";           
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if(ultraCalcManager1 == ultraGrid1.CalcManager)
            {
                int i = 0;
            }

            ultraCalcManager1.SuspendCalc();
            table.Rows.Clear();
            FillTable();
            ultraCalcManager1.ResumeCalc();
            ultraCalcManager1.ReCalc();
        }
    }
}
